package com.tofly.scada.service;


import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.IService;
import com.tofly.scada.entity.TfScadaReportList;
import org.springframework.web.multipart.MultipartFile;

import java.io.Serializable;
import java.util.List;
import java.util.Map;

/**
 * 报警数据存储(TfScadaReportList)表服务接口
 *
 * @author HaiQiu
 * @since 2022-09-21 16:21:21
 */
public interface TfScadaReportListService extends IService<TfScadaReportList> {

    /**
     * 根据ID查询
     *
     * @param id id
     * @return 数据
     */
    TfScadaReportList get(Serializable id);

    /**
     * 新增
     *
     * @param tfScadaReportList 实体
     */
    void insert(TfScadaReportList tfScadaReportList);

    /**
     * 修改
     *
     * @param tfScadaReportList 实体
     */
    void edit(TfScadaReportList tfScadaReportList);

    /**
     * 批量删除
     *
     * @param idList 数据ID集合
     */
    void delete(List<Long> idList);

    /**
     * 生成模板下载
     */
    void template();

    /**
     * 数据导入
     *
     * @param file 文件
     */
    void importData(MultipartFile file);

    /**
     * 分页查询
     *
     * @param page              分页
     * @param tfScadaReportList 查询wrapper
     * @return 数据集合
     */
    Page<TfScadaReportList> pageList(Page<TfScadaReportList> page, TfScadaReportList tfScadaReportList);

    /**
     * 数据导出
     *
     * @param page              分页
     * @param tfScadaReportList 查询模型
     * @param isAll             是否导出全部数据，true是，false否
     */
    void export(Page<TfScadaReportList> page, TfScadaReportList tfScadaReportList, Boolean isAll);

    /**
     * 查询所有数据
     *
     * @param tfScadaReportList 查询条件
     * @return 查询所有数据
     */
    List<TfScadaReportList> allList(TfScadaReportList tfScadaReportList);

    /**
     * 批量修改数据状态
     *
     * @param idList 主键结合
     * @return 修改结果
     */
    void change(List<Long> idList,String status,String dealRemark);

    List<Map<String,String>> getReportLevel(TfScadaReportList tfScadaReportList);


}

